﻿//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"

using namespace ExceptionSample;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::Storage;
using namespace Windows::Storage::Streams;
using namespace Concurrency;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

MainPage::MainPage()
{
	InitializeComponent();
}

/// <summary>
/// Invoked when this page is about to be displayed in a Frame.
/// </summary>
/// <param name="e">Event data that describes how this page was reached.  The Parameter
/// property is typically used to configure the page.</param>
void MainPage::OnNavigatedTo(NavigationEventArgs^ e)
{
	(void) e;	// Unused parameter
}

void ExceptionSample::MainPage::ThrowDataReaderError()
{
	DataReader^ dataReader = ref new DataReader(nullptr);
	dataReader->LoadAsync(100);
}

void ExceptionSample::MainPage::btnThrowHandled_Click_1(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	try
	{
		ThrowDataReaderError();
	}
	catch (Platform::Exception^ e)
	{
		OutputTextBlock->Text = e->Message;
	}
}

void ExceptionSample::MainPage::btnThrowUnhandled_Click_1(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	ThrowDataReaderError();
}

void ExceptionSample::MainPage::ThrowDataReaderErrorInsideTask()
{
	create_task(KnownFolders::DocumentsLibrary->CreateFileAsync(L"foo.txt", CreationCollisionOption::ReplaceExisting)).then([this](StorageFile^ file)
	{
		create_task(file->OpenAsync(FileAccessMode::Read)).then([this](IRandomAccessStream^ readStream)
		{
			DataReader^ dataReader = ref new DataReader(readStream);
			create_task(dataReader->LoadAsync(100)).then([this, dataReader](unsigned int numBytesLoaded)
			{
				String^ fileContent = dataReader->ReadString(100);
				OutputTextBlock->Text = fileContent;
				delete dataReader;
			});
		});
	});
}

void ExceptionSample::MainPage::btnThrowInsideTask_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	ThrowDataReaderErrorInsideTask();
}
